$regfile = "2313def.dat"
$baud = 9600
$crystal = 4000000

Sclpin Alias Pinb.4
Sclpout Alias Portb.4
Sdapin Alias Pinb.5
Sdapout Alias Portb.5
Config Portb = Output

Declare Sub I2c_kontrol                                     '
Declare Sub I2c_write_single                                'input dat=karakter
Declare Sub I2c_command_lcd                                 '
Declare Sub I2c_write_string
Declare Sub I2c_loc_ddram
Declare Sub I2c_set_contrast                                'input dat=tingkat kontrast
Declare Sub I2c_rddata_ddram
Declare Sub I2c_rdaddr_ddram
Declare Sub I2c_wbyte
Declare Sub I2c_rbyte
Declare Sub I2c_start
Declare Sub I2c_stop

Const Addr = &HEE                                           'Alamat SPC CHARACTER LCD
Const Lcd_control = &H00                                    'Command Control
Const Lcd_single = &H10                                     'Command Write Single Character
Const Lcd_multiple = &H20                                   'Command Write Multiple Character
Const Lcd_loc_ddram = &H30                                  'Command Locate DDRAM
Const Lcd_loc_cgram = &H40                                  'Command Locate CGRAM
Const Lcd_contrast = &H50                                   'Command Set Contrast
Const Lcd_data_ddram = &H60                                 'Command Read Data DDRAM
Const Lcd_data_cgram = &H70                                 'Command Read Data CGRAM
Const Lcd_addr_ddram = &H80                                 'Command Read Address DDRAM
Const Lcd_addr_cgram = &H90                                 'Command Read Address CGRAM
Const Lcd_lcd = &HA0                                        'Command untuk mengirimkan Command LCD

Dim Dat As Byte
Dim Read_addr As Byte
Dim I As Byte
Dim J As Byte
Dim K As Byte
Dim Acc As Byte
Dim Data_kolom As Byte
Dim Data_baris As Byte
Dim Ddram_data As Byte
Dim Fack As Byte


Dat = &H8E                                                  'Backlight|D/C|Left|Right|Direction|Display|Cursor|Blink
Call I2c_kontrol
Dat = 10
Call I2c_set_contrast
Dat = &H01
Call I2c_command_lcd
Dat = "h"
Call I2c_write_single
Dat = "e"
Call I2c_write_single
Dat = "l"
Call I2c_write_single
Dat = "l"
Call I2c_write_single
Dat = "o"
Call I2c_write_single
Data_kolom = 0
Data_baris = 2
Call I2c_loc_ddram
Restore Data_string1
Call I2c_write_string
Data_kolom = 0
Data_baris = 2
Call I2c_loc_ddram
For K = 0 To 9
   Call I2c_rddata_ddram
   Print Chr(dat);
Next
Wait 1
Dat = 5
Call I2c_set_contrast
Data_baris = 1
Data_kolom = 15
Call I2c_loc_ddram
Dat = &H07
Call I2c_kontrol
Restore Index
Call I2c_write_string

End


Sub I2c_kontrol
   Call I2c_start
   Ddram_data = Addr
   Call I2c_wbyte
   Ddram_data = Lcd_control
   Call I2c_wbyte
   Ddram_data = Dat
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3
End Sub

Sub I2c_write_single
   Call I2c_start
   Ddram_data = Addr
   Call I2c_wbyte
   Ddram_data = Lcd_single
   Call I2c_wbyte
   Ddram_data = Dat
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3
End Sub

Sub I2c_set_contrast
   Call I2c_start
   Ddram_data = Addr
   Call I2c_wbyte
   Ddram_data = Lcd_contrast
   Call I2c_wbyte
   Ddram_data = Dat
   Call I2c_wbyte
   Call I2c_stop

   Waitms 3
End Sub

Sub I2c_command_lcd
   Call I2c_start
   Ddram_data = Addr
   Call I2c_wbyte
   Ddram_data = Lcd_lcd
   Call I2c_wbyte
   Ddram_data = Dat
   Call I2c_wbyte
   Call I2c_stop

   Waitms 3
End Sub

Sub I2c_write_string
                                         'penetapan data string dilakukan diakhir pemrograman
   While Dat <> 0

      Call I2c_start
      Ddram_data = Addr
      Call I2c_wbyte
      Ddram_data = Lcd_multiple
      Call I2c_wbyte
      For J = 0 To 6
         Read Dat
         Ddram_data = Dat
         Call I2c_wbyte
         If Dat = 0 Then J = 7
      Next
      Call I2c_stop
      Waitms 3
    Wend
End Sub

Sub I2c_loc_ddram
   Call I2c_start
   Ddram_data = Addr
   Call I2c_wbyte
   Ddram_data = Lcd_loc_ddram
   Call I2c_wbyte
   Ddram_data = Data_kolom
   Call I2c_wbyte
   Ddram_data = Data_baris
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3
End Sub

Sub I2c_rddata_ddram
   Read_addr = Addr Or 1
   Call I2c_start
   Ddram_data = Addr
   Call I2c_wbyte
   Ddram_data = Lcd_data_ddram
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3

   Call I2c_start
   Ddram_data = Read_addr
   Call I2c_wbyte
   Call I2c_rbyte
   Dat = Ddram_data
   Call I2c_stop
   Waitms 3
End Sub

'Low Level Instruction
Sub I2c_start
   Sclpout = 0
   Sdapout = 1
   Waitus 5
   Sclpout = 1
   Waitus 5
   Sdapout = 0
   Waitus 5
End Sub

Sub I2c_stop
   Sclpout = 0
   Sdapout = 0
   Waitus 5
   Waitus 5
   Sclpout = 1
   Waitus 5
   Sdapout = 1
   Waitus 5
End Sub

Sub I2c_wbyte
   Acc = I
   For I = 7 To 0 Step -1
      Sclpout = 0
      Sdapout = Ddram_data.i
      Waitus 5
      Sclpout = 1
      Waitus 5
   Next
   Sclpout = 0
   Sdapout = 1
   Waitus 5
   Sclpout = 1
   Waitus 5
   Config Sdapin = Input
   Fack.0 = Sdapin
   Config Sdapin = Output
   I = Acc
End Sub

Sub I2c_rbyte
   Acc = I
   Config Sdapin = Input
   For I = 7 To 0 Step -1
      Waitus 5
      Sclpout = 0
      Ddram_data.i = Sdapin
      Waitus 5
      Sclpout = 1
      Ddram_data.i = Sdapin
   Next
   Waitus 5
   Config Sdapin = Output
   Sclpout = 0
   Sdapout = 1
   Waitus 5
   Sclpout = 1
   Waitus 5
   I = Acc
End Sub

Data_string1:
Data "innovative"
Index:
Data "electronics"