$regfile = "2313def.dat"
$baud = 9600
$crystal = 4000000

Declare Sub Write_sync_byte
Declare Sub Read_sync_byte
Declare Sub Reset_sync
Declare Sub Lcd_kontrol_ss
Declare Sub Lcd_writesingle_ss
Declare Sub Lcd_setcontrast_ss
Declare Sub Lcd_command_ss
Declare Sub Lcd_writestring_ss
Declare Sub Lcd_locddram_ss
Declare Sub Lcd_readddram_ss
Declare Sub Coba

Const Addr = &HE0                                           'Alamat SPC CHARACTER LCD hanya pada bit 7 s/d 5
Const Cmd_control = &H00                                    'Command Control
Const Cmd_single = &H01                                     'Command Write Single Character
Const Cmd_multiple = &H02                                   'Command Write Multiple Character
Const Cmd_loc_ddram = &H03                                  'Command Locate DDRAM
Const Cmd_loc_cgram = &H04                                  'Command Locate CGRAM
Const Cmd_contrast = &H05                                   'Command Set Contrast
Const Cmd_data_ddram = &H06                                 'Command Read Data DDRAM
Const Cmd_data_cgram = &H07                                 'Command Read Data CGRAM
Const Cmd_addr_ddram = &H08                                 'Command Read Address DDRAM
Const Cmd_addr_cgram = &H09                                 'Command Read Address CGRAM
Const Cmd_lcd = &H0A                                        'Command untuk mengirimkan Command LCD
Dim I As Byte
Dim J As Byte
Dim Dat As Byte
Dim Data_lcd As Byte
Dim Data_baris As Byte
Dim Data_kolom As Byte

Serclr Alias Portb.0
Serclk Alias Portb.2
Serdata Alias Portb.4
Serindata Alias Pinb.4


Config Portb = Output
Call Reset_sync
Data_lcd = &H8E
Call Lcd_kontrol_ss
Data_lcd = 7
Call Lcd_setcontrast_ss
Data_lcd = &H01
Call Lcd_command_ss
Data_lcd = "L"
Call Lcd_writesingle_ss
Data_lcd = "C"
Call Lcd_writesingle_ss
Data_lcd = "D"
Call Lcd_writesingle_ss
Data_baris = 2
Data_kolom = 0
Call Lcd_locddram_ss
Restore Data_string
Call Lcd_writestring_ss
Data_baris = 2
Data_kolom = 0
Call Lcd_locddram_ss
For J = 0 To 3
   Call Lcd_readddram_ss
   Print Chr(data_lcd);
Next
Wait 1
Data_lcd = &H07
Call Lcd_kontrol_ss
Data_lcd = 10
Data_baris = 1
Data_kolom = 15
Call Lcd_locddram_ss
Wait 1
Restore Data_string
Call Lcd_writestring_ss
End                                                         'end program

Sub Lcd_kontrol_ss
   Dat = Addr Or Cmd_control
   Call Write_sync_byte
   Waitms 1
   Dat = Data_lcd
   Call Write_sync_byte
   Waitms 1
End Sub

Sub Lcd_writesingle_ss
   Dat = Addr Or Cmd_single
   Call Write_sync_byte
   Dat = Data_lcd
   Call Write_sync_byte
End Sub

Sub Lcd_setcontrast_ss
   Dat = Addr Or Cmd_contrast
   Call Write_sync_byte
   Dat = Data_lcd
   Call Write_sync_byte
End Sub

Sub Lcd_command_ss
   Dat = Addr Or Cmd_lcd
   Call Write_sync_byte
   Dat = Data_lcd
   Call Write_sync_byte
End Sub

Sub Lcd_writestring_ss
   Dat = Addr Or Cmd_multiple
   Call Write_sync_byte
   While Dat <> 0
      Read Dat
      Call Write_sync_byte
   Wend
   Dat = 0
   Call Write_sync_byte
End Sub

Sub Lcd_locddram_ss
   Dat = Addr Or Cmd_loc_ddram
   Call Write_sync_byte
   Dat = Data_kolom
   Call Write_sync_byte
   Dat = Data_baris
   Call Write_sync_byte
End Sub

Sub Lcd_readddram_ss
   Dat = Addr Or Cmd_data_ddram
   Call Write_sync_byte
   Call Read_sync_byte
   Data_lcd = Dat
End Sub

Sub Reset_sync
   Serclk = 1
   Serclr = 0
   Waitms 2
   Serclr = 1
   Waitms 100
End Sub

Sub Write_sync_byte
   Waitms 1
   For I = 0 To 7
      Serclk = 1
      Serdata = Dat.i
      Waitus 15
      Serclk = 0
      Waitms 1
      Serclk = 1
   Next
   Serclk = 1
   Serdata = 1
End Sub

Sub Read_sync_byte
   Waitms 1
   For I = 0 To 7
      Serclk = 1
      Waitus 10
      Serclk = 0
      Waitus 15
      Serclk = 1
      Dat.i = Serindata
      Waitms 1
   Next
   Serclk = 1
   Serdata = 1
End Sub

Data_string:
Data "Sync Serial"